Selenium selenium+pytest 遇到的 ‘’ 由于目标计算机积极拒绝,无法连接 ‘’ 问题,该如何解决 多谢各位

林仔 · 2020年07月02日 · 最后由 林仔 回复于 2020年07月03日 · 386 次阅读

直接上代码

import pytest
from selenium import webdriver
import time


class Test_登录():
    driver = webdriver.Firefox()
    driver.implicitly_wait(10)


    def test_1(self):
        self.driver.get('https://www.baidu.com')
        time.sleep(2)
        self.driver.quit()



    def test_2(self):
        self.driver.get('https://www.baidu.com')
        time.sleep(2)
        self.driver.quit()

就是这么两条 case,运行起来后,第一条通过,第二条 case 报错 由于目标计算机积极拒绝,无法连接 ‘
以下是控制台报的错误:

E:\Panda_test\venv\Scripts\python.exe D:/test_auto/run.py
Active code page: 65001
============================= test session starts =============================
platform win32 -- Python 3.7.0, pytest-5.4.3, py-1.9.0, pluggy-0.13.1 -- E:\Panda_test\venv\Scripts\python.exe
cachedir: .pytest_cache
rootdir: D:\test_auto
collecting ... collected 2 items

cases/登录模块/test_登录.py::Test_登录::test_1 PASSED
cases/登录模块/test_登录.py::Test_登录::test_2 FAILED

================================== FAILURES ===================================
_______________________________ Test_登录.test_2 ________________________________

self =

def _new_conn(self):
""" Establish a socket connection and set nodelay settings on it.

:return: New socket connection.
"""
extra_kw = {}
if self.source_address:
extra_kw["source_address"] = self.source_address

if self.socket_options:
extra_kw["socket_options"] = self.socket_options

try:
conn = connection.create_connection(

(self._dns_host, self.port), self.timeout, **extra_kw
)

E:\Panda_test\venv\lib\site-packages\urllib3\connection.py:160:


address = ('127.0.0.1', 51773), timeout =
source_address = None, socket_options = [(6, 1, 1)]

def create_connection(
address,
timeout=socket._GLOBAL_DEFAULT_TIMEOUT,
source_address=None,
socket_options=None,
):
"""Connect to address and return the socket object.

Convenience function. Connect to address (a 2-tuple (host,
port)
) and return the socket object. Passing the optional
timeout parameter will set the timeout on the socket instance
before attempting to connect. If no timeout is supplied, the
global default timeout setting returned by :func:getdefaulttimeout
is used. If source_address is set it must be a tuple of (host, port)
for the socket to bind as a source address before making the connection.
An host of '' or port 0 tells the OS to use the default.
"""

host, port = address
if host.startswith("["):
host = host.strip("[]")
err = None

# Using the value from allowed_gai_family() in the context of getaddrinfo lets
# us select whether to work with IPv4 DNS records, IPv6 records, or both.
# The original create_connection function always returns all records.
family = allowed_gai_family()

for res in socket.getaddrinfo(host, port, family, socket.SOCK_STREAM):
af, socktype, proto, canonname, sa = res
sock = None
try:
sock = socket.socket(af, socktype, proto)

# If provided, set socket level options before connecting.
_set_socket_options(sock, socket_options)

if timeout is not socket._GLOBAL_DEFAULT_TIMEOUT:
sock.settimeout(timeout)
if source_address:
sock.bind(source_address)
sock.connect(sa)
return sock

except socket.error as e:
err = e
if sock is not None:
sock.close()
sock = None

if err is not None:

raise err

E:\Panda_test\venv\lib\site-packages\urllib3\util\connection.py:84:


address = ('127.0.0.1', 51773), timeout =
source_address = None, socket_options = [(6, 1, 1)]

def create_connection(
address,
timeout=socket._GLOBAL_DEFAULT_TIMEOUT,
source_address=None,
socket_options=None,
):
"""Connect to address and return the socket object.

Convenience function. Connect to address (a 2-tuple (host,
port)
) and return the socket object. Passing the optional
timeout parameter will set the timeout on the socket instance
before attempting to connect. If no timeout is supplied, the
global default timeout setting returned by :func:getdefaulttimeout
is used. If source_address is set it must be a tuple of (host, port)
for the socket to bind as a source address before making the connection.
An host of '' or port 0 tells the OS to use the default.
"""

host, port = address
if host.startswith("["):
host = host.strip("[]")
err = None

# Using the value from allowed_gai_family() in the context of getaddrinfo lets
# us select whether to work with IPv4 DNS records, IPv6 records, or both.
# The original create_connection function always returns all records.
family = allowed_gai_family()

for res in socket.getaddrinfo(host, port, family, socket.SOCK_STREAM):
af, socktype, proto, canonname, sa = res
sock = None
try:
sock = socket.socket(af, socktype, proto)

# If provided, set socket level options before connecting.
_set_socket_options(sock, socket_options)

if timeout is not socket._GLOBAL_DEFAULT_TIMEOUT:
sock.settimeout(timeout)
if source_address:
sock.bind(source_address)

sock.connect(sa)
E ConnectionRefusedError: [WinError 10061] 由于目标计算机积极拒绝,无法连接。

E:\Panda_test\venv\lib\site-packages\urllib3\util\connection.py:74: ConnectionRefusedError

During handling of the above exception, another exception occurred:

self =
method = 'POST', url = '/session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url'
body = '{"url": "https://www.baidu.com"}'
headers = {'Accept': 'application/json', 'Connection': 'keep-alive', 'Content-Type': 'application/json;charset=UTF-8', 'User-Agent': 'selenium/3.141.0 (python windows)'}
retries = Retry(total=0, connect=None, read=None, redirect=None, status=None)
redirect = False, assert_same_host = False
timeout = , pool_timeout = None
release_conn = True, chunked = False, body_pos = None
response_kw = {'request_url': 'http://127.0.0.1:51773/session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url'}
conn = None, release_this_conn = True, err = None, clean_exit = False
timeout_obj = Timeout(connect=, read=, total=None)
is_new_proxy_conn = False

def urlopen(
self,
method,
url,
body=None,
headers=None,
retries=None,
redirect=True,
assert_same_host=True,
timeout=_Default,
pool_timeout=None,
release_conn=None,
chunked=False,
body_pos=None,
**response_kw
):
"""
Get a connection from the pool and perform an HTTP request. This is the
lowest level call for making a request, so you'll need to specify all
the raw details.

.. note::

More commonly, it's appropriate to use a convenience method provided
by :class:.RequestMethods, such as :meth:request.

.. note::

release_conn will only behave as expected if
preload_content=False because we want to make
preload_content=False the default behaviour someday soon without
breaking backwards compatibility.

:param method:
HTTP request method (such as GET, POST, PUT, etc.)

:param body:
Data to send in the request body (useful for creating
POST requests, see HTTPConnectionPool.post_url for
more convenience).

:param headers:
Dictionary of custom headers to send, such as User-Agent,
If-None-Match, etc. If None, pool headers are used. If provided,
these headers completely replace any pool-specific headers.

:param retries:
Configure the number of retries to allow before raising a
:class:~urllib3.exceptions.MaxRetryError exception.

Pass None to retry until you receive a response. Pass a
:class:~urllib3.util.retry.Retry object for fine-grained control
over different types of retries.
Pass an integer number to retry connection errors that many times,
but no other types of errors. Pass zero to never retry.

If False, then retries are disabled and any exception is raised
immediately. Also, instead of raising a MaxRetryError on redirects,
the redirect response will be returned.

:type retries: :class:~urllib3.util.retry.Retry, False, or an int.

:param redirect:
If True, automatically handle redirects (status codes 301, 302,
303, 307, 308). Each redirect counts as a retry. Disabling retries
will disable redirect, too.

:param assert_same_host:
If True, will make sure that the host of the pool requests is
consistent else will raise HostChangedError. When False, you can
use the pool on an HTTP proxy and request foreign hosts.

:param timeout:
If specified, overrides the default timeout for this one
request. It may be a float (in seconds) or an instance of
:class:urllib3.util.Timeout.

:param pool_timeout:
If set and the pool is set to block=True, then this method will
block for pool_timeout seconds and raise EmptyPoolError if no
connection is available within the time period.

:param release_conn:
If False, then the urlopen call will not release the connection
back into the pool once a response is received (but will release if
you read the entire contents of the response such as when
preload_content=True). This is useful if you're not preloading
the response's content immediately. You will need to call
r.release_conn() on the response r to return the connection
back into the pool. If None, it takes the value of
response_kw.get('preload_content', True).

:param chunked:
If True, urllib3 will send the body using chunked transfer
encoding. Otherwise, urllib3 will send the body using the standard
content-length form. Defaults to False.

:param int body_pos:
Position to seek to in file-like body in the event of a retry or
redirect. Typically this won't need to be set because urllib3 will
auto-populate the value when needed.

:param \**response_kw:
Additional parameters are passed to
:meth:urllib3.response.HTTPResponse.from_httplib
"""
if headers is None:
headers = self.headers

if not isinstance(retries, Retry):
retries = Retry.from_int(retries, redirect=redirect, default=self.retries)

if release_conn is None:
release_conn = response_kw.get("preload_content", True)

# Check host
if assert_same_host and not self.is_same_host(url):
raise HostChangedError(self, url, retries)

# Ensure that the URL we're connecting to is properly encoded
if url.startswith("/"):
url = six.ensure_str(_encode_target(url))
else:
url = six.ensure_str(parse_url(url).url)

conn = None

# Track whether conn needs to be released before
# returning/raising/recursing. Update this variable if necessary, and
# leave release_conn constant throughout the function. That way, if
# the function recurses, the original value of release_conn will be
# passed down into the recursive call, and its value will be respected.
#
# See issue #651 [1] for details.
#
# [1] https://github.com/urllib3/urllib3/issues/651
release_this_conn = release_conn

# Merge the proxy headers. Only do this in HTTP. We have to copy the
# headers dict so we can safely change it without those changes being
# reflected in anyone else's copy.
if self.scheme == "http":
headers = headers.copy()
headers.update(self.proxy_headers)

# Must keep the exception bound to a separate variable or else Python 3
# complains about UnboundLocalError.
err = None

# Keep track of whether we cleanly exited the except block. This
# ensures we do proper cleanup in finally.
clean_exit = False

# Rewind body position, if needed. Record current position
# for future rewinds in the event of a redirect/retry.
body_pos = set_file_position(body, body_pos)

try:
# Request a connection from the queue.
timeout_obj = self._get_timeout(timeout)
conn = self._get_conn(timeout=pool_timeout)

conn.timeout = timeout_obj.connect_timeout

is_new_proxy_conn = self.proxy is not None and not getattr(
conn, "sock", None
)
if is_new_proxy_conn:
self._prepare_proxy(conn)

# Make the request on the httplib connection object.
httplib_response = self._make_request(
conn,
method,
url,
timeout=timeout_obj,
body=body,
headers=headers,

chunked=chunked,
)

E:\Panda_test\venv\lib\site-packages\urllib3\connectionpool.py:677:


self =
conn =
method = 'POST', url = '/session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url'
timeout = Timeout(connect=, read=, total=None)
chunked = False
httplib_request_kw = {'body': '{"url": "https://www.baidu.com"}', 'headers': {'Accept': 'application/json', 'Connection': 'keep-alive', 'Content-Type': 'application/json;charset=UTF-8', 'User-Agent': 'selenium/3.141.0 (python windows)'}}
timeout_obj = Timeout(connect=, read=, total=None)

def _make_request(
self, conn, method, url, timeout=_Default, chunked=False, **httplib_request_kw
):
"""
Perform a request on a given urllib connection object taken from our
pool.

:param conn:
a connection from one of our connection pools

:param timeout:
Socket timeout in seconds for the request. This can be a
float or integer, which will set the same timeout value for
the socket connect and the socket read, or an instance of
:class:urllib3.util.Timeout, which gives you more fine-grained
control over your timeouts.
"""
self.num_requests += 1

timeout_obj = self._get_timeout(timeout)
timeout_obj.start_connect()
conn.timeout = timeout_obj.connect_timeout

# Trigger any extra validation we need to do.
try:
self._validate_conn(conn)
except (SocketTimeout, BaseSSLError) as e:
# Py2 raises this as a BaseSSLError, Py3 raises it as socket timeout.
self._raise_timeout(err=e, url=url, timeout_value=conn.timeout)
raise

# conn.request() calls httplib.*.request, not the method in
# urllib3.request. It also calls makefile (recv) on the socket.
if chunked:
conn.request_chunked(method, url, **httplib_request_kw)
else:

conn.request(method, url, **httplib_request_kw)

E:\Panda_test\venv\lib\site-packages\urllib3\connectionpool.py:392:


self =
method = 'POST', url = '/session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url'
body = '{"url": "https://www.baidu.com"}'
headers = {'Accept': 'application/json', 'Connection': 'keep-alive', 'Content-Type': 'application/json;charset=UTF-8', 'User-Agent': 'selenium/3.141.0 (python windows)'}

def request(self, method, url, body=None, headers={}, *,
encode_chunked=False):
"""Send a complete request to the server."""

self._send_request(method, url, body, headers, encode_chunked)

C:\Users\Administrator\AppData\Local\Programs\Python\Python37\lib\http\client.py:1229:


self =
method = 'POST', url = '/session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url'
body = b'{"url": "https://www.baidu.com"}'
headers = {'Accept': 'application/json', 'Connection': 'keep-alive', 'Content-Type': 'application/json;charset=UTF-8', 'User-Agent': 'selenium/3.141.0 (python windows)'}
encode_chunked = False

def _send_request(self, method, url, body, headers, encode_chunked):
# Honor explicitly requested Host: and Accept-Encoding: headers.
header_names = frozenset(k.lower() for k in headers)
skips = {}
if 'host' in header_names:
skips['skip_host'] = 1
if 'accept-encoding' in header_names:
skips['skip_accept_encoding'] = 1

self.putrequest(method, url, **skips)

# chunked encoding will happen if HTTP/1.1 is used and either
# the caller passes encode_chunked=True or the following
# conditions hold:
# 1. content-length has not been explicitly set
# 2. the body is a file or iterable, but not a str or bytes-like
# 3. Transfer-Encoding has NOT been explicitly set by the caller

if 'content-length' not in header_names:
# only chunk body if not explicitly set for backwards
# compatibility, assuming the client code is already handling the
# chunking
if 'transfer-encoding' not in header_names:
# if content-length cannot be automatically determined, fall
# back to chunked encoding
encode_chunked = False
content_length = self._get_content_length(body, method)
if content_length is None:
if body is not None:
if self.debuglevel > 0:
print('Unable to determine size of %r' % body)
encode_chunked = True
self.putheader('Transfer-Encoding', 'chunked')
else:
self.putheader('Content-Length', str(content_length))
else:
encode_chunked = False

for hdr, value in headers.items():
self.putheader(hdr, value)
if isinstance(body, str):
# RFC 2616 Section 3.7.1 says that text default has a
# default charset of iso-8859-1.
body = _encode(body, 'body')

self.endheaders(body, encode_chunked=encode_chunked)

C:\Users\Administrator\AppData\Local\Programs\Python\Python37\lib\http\client.py:1275:


self =
message_body = b'{"url": "https://www.baidu.com"}'

def endheaders(self, message_body=None, *, encode_chunked=False):
"""Indicate that the last header line has been sent to the server.

This method sends the request to the server. The optional message_body
argument can be used to pass a message body associated with the
request.
"""
if self.state == _CS_REQ_STARTED:
self.
state = _CS_REQ_SENT
else:
raise CannotSendHeader()

self._send_output(message_body, encode_chunked=encode_chunked)

C:\Users\Administrator\AppData\Local\Programs\Python\Python37\lib\http\client.py:1224:


self =
message_body = b'{"url": "https://www.baidu.com"}', encode_chunked = False

def _send_output(self, message_body=None, encode_chunked=False):
"""Send the currently buffered request and clear the buffer.

Appends an extra \r\n to the buffer.
A message_body may be specified, to be appended to the request.
"""
self._buffer.extend((b"", b""))
msg = b"\r\n".join(self._buffer)
del self._buffer[:]

self.send(msg)

C:\Users\Administrator\AppData\Local\Programs\Python\Python37\lib\http\client.py:1016:


self =
data = b'POST /session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url HTTP/1.1\r\nHost: 127.0.0.1:51773\r\nAccept-Encoding: identit...ype: application/json;charset=UTF-8\r\nUser-Agent: selenium/3.141.0 (python windows)\r\nConnection: keep-alive\r\n\r\n'

def send(self, data):
"""Send data' to the server.
data` can be a string object, a bytes object, an array object, a
file-like object that supports a .read() method, or an iterable object.
"""

if self.sock is None:
if self.auto_open:

self.connect()

C:\Users\Administrator\AppData\Local\Programs\Python\Python37\lib\http\client.py:956:


self =

def connect(self):

conn = self._new_conn()

E:\Panda_test\venv\lib\site-packages\urllib3\connection.py:187:


self =

def _new_conn(self):
""" Establish a socket connection and set nodelay settings on it.

:return: New socket connection.
"""
extra_kw = {}
if self.source_address:
extra_kw["source_address"] = self.source_address

if self.socket_options:
extra_kw["socket_options"] = self.socket_options

try:
conn = connection.create_connection(
(self._dns_host, self.port), self.timeout, **extra_kw
)

except SocketTimeout:
raise ConnectTimeoutError(
self,
"Connection to %s timed out. (connect timeout=%s)"
% (self.host, self.timeout),
)

except SocketError as e:
raise NewConnectionError(

self, "Failed to establish a new connection: %s" % e
)
E urllib3.exceptions.NewConnectionError: : Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。

E:\Panda_test\venv\lib\site-packages\urllib3\connection.py:172: NewConnectionError

During handling of the above exception, another exception occurred:

self =

def test_2(self):

self.driver.get('https://www.baidu.com')

cases\登录模块\test_登录.py:32:


E:\Panda_test\venv\lib\site-packages\selenium\webdriver\remote\webdriver.py:333: in get
self.execute(Command.GET, {'url': url})
E:\Panda_test\venv\lib\site-packages\selenium\webdriver\remote\webdriver.py:319: in execute
response = self.command_executor.execute(driver_command, params)
E:\Panda_test\venv\lib\site-packages\selenium\webdriver\remote\remote_connection.py:374: in execute
return self._request(command_info[0], url, body=data)
E:\Panda_test\venv\lib\site-packages\selenium\webdriver\remote\remote_connection.py:397: in _request
resp = self._conn.request(method, url, body=body, headers=headers)
E:\Panda_test\venv\lib\site-packages\urllib3\request.py:80: in request
method, url, fields=fields, headers=headers, **urlopen_kw
E:\Panda_test\venv\lib\site-packages\urllib3\request.py:171: in request_encode_body
return self.urlopen(method, url, **extra_kw)
E:\Panda_test\venv\lib\site-packages\urllib3\poolmanager.py:336: in urlopen
response = conn.urlopen(method, u.request_uri, **kw)
E:\Panda_test\venv\lib\site-packages\urllib3\connectionpool.py:765: in urlopen
**response_kw
E:\Panda_test\venv\lib\site-packages\urllib3\connectionpool.py:765: in urlopen
**response_kw
E:\Panda_test\venv\lib\site-packages\urllib3\connectionpool.py:765: in urlopen
**response_kw
E:\Panda_test\venv\lib\site-packages\urllib3\connectionpool.py:725: in urlopen
method, url, error=e, _pool=self, _stacktrace=sys.exc_info()[2]


self = Retry(total=0, connect=None, read=None, redirect=None, status=None)
method = 'POST', url = '/session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url'
response = None
error = NewConnectionError(': Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。')
_pool =
_stacktrace =

def increment(
self,
method=None,
url=None,
response=None,
error=None,
_pool=None,
_stacktrace=None,
):
""" Return a new Retry object with incremented retry counters.

:param response: A response object, or None, if the server did not
return a response.
:type response: :class:~urllib3.response.HTTPResponse
:param Exception error: An error encountered during the request, or
None if the response was received successfully.

:return: A new Retry object.
"""
if self.total is False and error:
# Disabled, indicate to re-raise the error.
raise six.reraise(type(error), error, _stacktrace)

total = self.total
if total is not None:
total -= 1

connect = self.connect
read = self.read
redirect = self.redirect
status_count = self.status
cause = "unknown"
status = None
redirect_location = None

if error and self._is_connection_error(error):
# Connect retry?
if connect is False:
raise six.reraise(type(error), error, _stacktrace)
elif connect is not None:
connect -= 1

elif error and self._is_read_error(error):
# Read retry?
if read is False or not self._is_method_retryable(method):
raise six.reraise(type(error), error, _stacktrace)
elif read is not None:
read -= 1

elif response and response.get_redirect_location():
# Redirect retry?
if redirect is not None:
redirect -= 1
cause = "too many redirects"
redirect_location = response.get_redirect_location()
status = response.status

else:
# Incrementing because of a server error like a 500 in
# status_forcelist and a the given method is in the whitelist
cause = ResponseError.GENERIC_ERROR
if response and response.status:
if status_count is not None:
status_count -= 1
cause = ResponseError.SPECIFIC_ERROR.format(status_code=response.status)
status = response.status

history = self.history + (
RequestHistory(method, url, error, status, redirect_location),
)

new_retry = self.new(
total=total,
connect=connect,
read=read,
redirect=redirect,
status=status_count,
history=history,
)

if new_retry.is_exhausted():

raise MaxRetryError(_pool, url, error or ResponseError(cause))
E urllib3.exceptions.MaxRetryError: HTTPConnectionPool(host='127.0.0.1', port=51773): Max retries exceeded with url: /session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url (Caused by NewConnectionError(': Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。'))

E:\Panda_test\venv\lib\site-packages\urllib3\util\retry.py:439: MaxRetryError
------------------------------ Captured log call ------------------------------
WARNING urllib3.connectionpool:connectionpool.py:750 Retrying (Retry(total=2, connect=None, read=None, redirect=None, status=None)) after connection broken by 'NewConnectionError(': Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。')': /session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url
WARNING urllib3.connectionpool:connectionpool.py:750 Retrying (Retry(total=1, connect=None, read=None, redirect=None, status=None)) after connection broken by 'NewConnectionError(': Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。')': /session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url
WARNING urllib3.connectionpool:connectionpool.py:750 Retrying (Retry(total=0, connect=None, read=None, redirect=None, status=None)) after connection broken by 'NewConnectionError(': Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。')': /session/9555d23d-401f-43f3-a4cc-a05a2104a3a1/url
=========================== short test summary info ===========================
FAILED cases/登录模块/test_登录.py::Test_登录::test_2 - urllib3.exceptions.Ma...
======================== 1 failed, 1 passed in 22.83s =========================

Process finished with exit code 0

共收到 4 条回复 时间 点赞

要不你试试把 quit 先去掉

你第一条 case 已经把 driver 停掉啦
你这种情况建议把 driver 初始化的动作放在 test setup 里面,这样每条 case 执行之前都会初始化一个新的 driver

刘旭 回复

我试了一下,把 driver 放在初始化方法里就好了,这个问题应该是 quit 之后 driver 直接释放掉,case2 就找不到 driver 了

Jerry li 回复

嗯嗯 谢谢

需要 登录 后方可回复, 如果你还没有账号请点击这里 注册